/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.stimmzettel.entity;

@javax.persistence.NamedQueries(
 {



       @javax.persistence.NamedQuery(
     name="STIMMZETTEL.UK",
     query="SELECT o FROM Stimmzettel o WHERE "

                         + "o"
                +".nummer"
              +" = ?1"

             +" AND "         + "o"
                +".gebiet"
                +".nummer"
              +" = ?2"

             +" AND "         + "o"
                +".gebiet"
                +".gebietsart"
                +".name"
              +" = ?3"

             +" AND "         + "o"
                +".gebiet"
                +".gebietsart"
                +".mandant"
                +".nummer"
              +" = ?4"

             +" AND "         + "o"
                +".gebiet"
                +".wahl"
                +".wahlart"
                +".name"
              +" = ?5"

             +" AND "         + "o"
                +".gebiet"
                +".wahl"
                +".wahlart"
                +".mandant"
                +".nummer"
              +" = ?6"

             +" AND "         + "o"
                +".gebiet"
                +".wahl"
                +".wahltermin"
                +".nummer"
              +" = ?7"

             +" AND "         + "o"
                +".gebiet"
                +".wahl"
                +".wahltermin"
                +".wahldatum"
              +" = ?8"

             +" AND "         + "o"
                +".gebiet"
                +".wahl"
                +".wahltermin"
                +".mandant"
                +".nummer"
              +" = ?9"

             +" AND "         + "o"
                +".gebiet"
                +".wahltermin"
                +".nummer"
              +" = ?10"

             +" AND "         + "o"
                +".gebiet"
                +".wahltermin"
                +".wahldatum"
              +" = ?11"

             +" AND "         + "o"
                +".gebiet"
                +".wahltermin"
                +".mandant"
                +".nummer"
              +" = ?12"

     ,
   hints = {
              @javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
             @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
   }


   )
   
     ,   @javax.persistence.NamedQuery(
     name="STIMMZETTEL.ByGebietAndStimmzettelteam",
     query="DELETE FROM Stimmzettel o WHERE o.gebiet = ?1 AND o.stimmzettelTeam = ?2",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="STIMMZETTEL.ByGebiet",
     query="DELETE FROM Stimmzettel o WHERE o.gebiet = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="STIMMZETTEL.GebietAndStimmzettelteam",
     query="SELECT o FROM Stimmzettel o WHERE o.gebiet=?1 AND o.stimmzettelTeam = ?2",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="STIMMZETTEL.GebietCount",
     query="SELECT COUNT(o) FROM Stimmzettel o WHERE o.gebiet=?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="STIMMZETTEL.Gebiet",
     query="SELECT o FROM Stimmzettel o WHERE o.gebiet=?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="STIMMZETTEL.Wahl",
     query="SELECT o FROM Stimmzettel o WHERE o.gebiet.wahl=?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "STIMMZETTEL")
// @javax.persistence.IdClass(StimmzettelPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable

public
 class Stimmzettel
extends AbstractStimmzettel
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor (protected, da mit CustomData aufgerufen werden muss)
   */
  protected Stimmzettel() {
    super();
  }
    public Stimmzettel(de.ivu.elect.jee.entity.customdata.CustomData customData){
                      if (customData != null && de.ivu.elect.jee.entity.customdata.EmptyCustomData.INSTANCE != customData) {
          customData.setTechnicalEntity(this);
          customDataStorage = new de.ivu.elect.business.customdata.entity.CustomDataStorage(customData);
        }
            }



    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public Stimmzettel(Stimmzettel original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "stimmzettel_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "Stimmzettel")
    @javax.persistence.TableGenerator(name = "Stimmzettel", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "Stimmzettel", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient StimmzettelPK pkCache;

  @Override
  public StimmzettelPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new StimmzettelPK(getId());
    }

    return pkCache;
  }

  public static <E extends Stimmzettel> java.util.Map<StimmzettelPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<StimmzettelPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends Stimmzettel> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;


  public void resetAttributeChanged() {
        hasChangedBemerkung = false;
          hasChangedErfasser = false;
          hasChangedErfassungszeitpunkt = false;
          hasChangedGueltigkeit = false;
          hasChangedNummer = false;
          hasChangedStatus = false;
          hasChangedStimmzettelTeam = false;
          hasChangedVersionsnummer = false;
  
      hasChangedCustomDataStorage = false;
        hasChangedGebiet = false;
  


    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
  @javax.persistence.Column(name = "BEMERKUNG", nullable = StimmzettelConstants.BEMERKUNG_NULLABLE, length=StimmzettelConstants.BEMERKUNG_MAX_LENGTH)
        
  protected java.lang.String bemerkung =  null;

  @javax.persistence.Transient
  protected boolean hasChangedBemerkung = false;

  public boolean hasChangedBemerkung(){
    return hasChangedBemerkung;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertBemerkung = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenBemerkung;
  
  /**
   * 
   *
   * getter for STIMMZETTEL.BEMERKUNG
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getBemerkung() {
        return bemerkung;
      }

  /**
   * 
   *
   * setter for STIMMZETTEL.BEMERKUNG
   *
   * @param bemerkung
   */
  @Override   public void setBemerkung(@javax.annotation.Nullable  java.lang.String bemerkung) {

       resetTkCache();
                  
                          java.lang.String bemerkungInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(bemerkung, StimmzettelConstants.BEMERKUNG_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.bemerkung
      , bemerkungInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedBemerkung |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("bemerkung");
      }


             if (!isSeitLadenVeraendertBemerkung) {
          isSeitLadenVeraendertBemerkung = thisAttributChanged;
         if (isSeitLadenVeraendertBemerkung){
           wertNachLadenBemerkung=this.bemerkung;
         }
       }
      

       this.bemerkung = bemerkungInternal;

         }

        
  @javax.persistence.Column(name = "ERFASSER", nullable = StimmzettelConstants.ERFASSER_NULLABLE, length=StimmzettelConstants.ERFASSER_MAX_LENGTH)
        
  protected java.lang.String erfasser =  null;

  @javax.persistence.Transient
  protected boolean hasChangedErfasser = false;

  public boolean hasChangedErfasser(){
    return hasChangedErfasser;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertErfasser = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenErfasser;
  
  /**
   * 
   *
   * getter for STIMMZETTEL.ERFASSER
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getErfasser() {
        return erfasser;
      }

  /**
   * 
   *
   * setter for STIMMZETTEL.ERFASSER
   *
   * @param erfasser
   */
  @Override   public void setErfasser(@javax.annotation.Nullable  java.lang.String erfasser) {

       resetTkCache();
                  
                          java.lang.String erfasserInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(erfasser, StimmzettelConstants.ERFASSER_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.erfasser
      , erfasserInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedErfasser |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("erfasser");
      }


             if (!isSeitLadenVeraendertErfasser) {
          isSeitLadenVeraendertErfasser = thisAttributChanged;
         if (isSeitLadenVeraendertErfasser){
           wertNachLadenErfasser=this.erfasser;
         }
       }
      

       this.erfasser = erfasserInternal;

         }

        
  @javax.persistence.Temporal(javax.persistence.TemporalType.TIMESTAMP)
  @javax.persistence.Column(name = "ERFASSUNGSZEITPUNKT", nullable = StimmzettelConstants.ERFASSUNGSZEITPUNKT_NULLABLE, precision=StimmzettelConstants.ERFASSUNGSZEITPUNKT_PRECISION)
    
  protected java.util.Date erfassungszeitpunkt =  null;

  @javax.persistence.Transient
  protected boolean hasChangedErfassungszeitpunkt = false;

  public boolean hasChangedErfassungszeitpunkt(){
    return hasChangedErfassungszeitpunkt;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertErfassungszeitpunkt = false;
     @javax.persistence.Transient
     private transient java.util.Date wertNachLadenErfassungszeitpunkt;
  
  /**
   * 
   *
   * getter for STIMMZETTEL.ERFASSUNGSZEITPUNKT
   */
  @javax.annotation.Nullable   @Override   public  java.util.Date getErfassungszeitpunkt() {
              if (erfassungszeitpunkt == null){
            return null;
          } else {
                          return erfassungszeitpunkt;
          }
      }

  /**
   * 
   *
   * setter for STIMMZETTEL.ERFASSUNGSZEITPUNKT
   *
   * @param erfassungszeitpunkt
   */
  @Override   public void setErfassungszeitpunkt(@javax.annotation.Nullable  java.util.Date erfassungszeitpunkt) {

       resetTkCache();
                  java.util.Date erfassungszeitpunktInternal = de.ivu.elect.jee.entity.EntityUtil.normalizeDateTime(erfassungszeitpunkt);
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.erfassungszeitpunkt
      , erfassungszeitpunktInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedErfassungszeitpunkt |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("erfassungszeitpunkt");
      }


             if (!isSeitLadenVeraendertErfassungszeitpunkt) {
          isSeitLadenVeraendertErfassungszeitpunkt = thisAttributChanged;
         if (isSeitLadenVeraendertErfassungszeitpunkt){
           wertNachLadenErfassungszeitpunkt=this.erfassungszeitpunkt;
         }
       }
      

       this.erfassungszeitpunkt = erfassungszeitpunktInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "GUELTIGKEIT", nullable = StimmzettelConstants.GUELTIGKEIT_NULLABLE)
    
  protected de.ivu.elect.business.stimmzettel.entity.StimmzettelGueltigkeit gueltigkeit =  de.ivu.elect.business.stimmzettel.entity.StimmzettelGueltigkeit.UNBEKANNT;

  @javax.persistence.Transient
  protected boolean hasChangedGueltigkeit = false;

  public boolean hasChangedGueltigkeit(){
    return hasChangedGueltigkeit;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertGueltigkeit = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.stimmzettel.entity.StimmzettelGueltigkeit wertNachLadenGueltigkeit;
  
  /**
   * 
   *
   * getter for STIMMZETTEL.GUELTIGKEIT
   */
    @Override   public  de.ivu.elect.business.stimmzettel.entity.StimmzettelGueltigkeit getGueltigkeit() {
        return gueltigkeit;
      }

  /**
   * 
   *
   * setter for STIMMZETTEL.GUELTIGKEIT
   *
   * @param gueltigkeit
   */
  @Override   public void setGueltigkeit( de.ivu.elect.business.stimmzettel.entity.StimmzettelGueltigkeit gueltigkeit) {

       resetTkCache();
                  de.ivu.elect.business.stimmzettel.entity.StimmzettelGueltigkeit gueltigkeitInternal = gueltigkeit;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.gueltigkeit
      , gueltigkeitInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedGueltigkeit |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("gueltigkeit");
      }


             if (!isSeitLadenVeraendertGueltigkeit) {
          isSeitLadenVeraendertGueltigkeit = thisAttributChanged;
         if (isSeitLadenVeraendertGueltigkeit){
           wertNachLadenGueltigkeit=this.gueltigkeit;
         }
       }
      

       this.gueltigkeit = gueltigkeitInternal;

         }

        
      @javax.persistence.Column(name = "NUMMER", nullable = StimmzettelConstants.NUMMER_NULLABLE, length=StimmzettelConstants.NUMMER_MAX_LENGTH)
        
  protected java.lang.String nummer =  null;

  @javax.persistence.Transient
  protected boolean hasChangedNummer = false;

  public boolean hasChangedNummer(){
    return hasChangedNummer;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertNummer = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenNummer;
  
  /**
   * 
   *
   * getter for STIMMZETTEL.NUMMER
   */
    @Override   public  java.lang.String getNummer() {
        return nummer;
      }

  /**
   * 
   *
   * setter for STIMMZETTEL.NUMMER
   *
   * @param nummer
   */
  @Override   public void setNummer( java.lang.String nummer) {

       resetTkCache();
                  
                          java.lang.String nummerInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(nummer, StimmzettelConstants.NUMMER_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.nummer
      , nummerInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedNummer |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("nummer");
      }


             if (!isSeitLadenVeraendertNummer) {
          isSeitLadenVeraendertNummer = thisAttributChanged;
         if (isSeitLadenVeraendertNummer){
           wertNachLadenNummer=this.nummer;
         }
       }
      

       this.nummer = nummerInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "STATUS", nullable = StimmzettelConstants.STATUS_NULLABLE)
    
  protected de.ivu.elect.business.stimmzettel.entity.StimmzettelStatus status =  de.ivu.elect.business.stimmzettel.entity.StimmzettelStatus.INITIAL;

  @javax.persistence.Transient
  protected boolean hasChangedStatus = false;

  public boolean hasChangedStatus(){
    return hasChangedStatus;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertStatus = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.stimmzettel.entity.StimmzettelStatus wertNachLadenStatus;
  
  /**
   * 
   *
   * getter for STIMMZETTEL.STATUS
   */
    @Override   public  de.ivu.elect.business.stimmzettel.entity.StimmzettelStatus getStatus() {
        return status;
      }

  /**
   * 
   *
   * setter for STIMMZETTEL.STATUS
   *
   * @param status
   */
  @Override   public void setStatus( de.ivu.elect.business.stimmzettel.entity.StimmzettelStatus status) {

       resetTkCache();
                  de.ivu.elect.business.stimmzettel.entity.StimmzettelStatus statusInternal = status;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.status
      , statusInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedStatus |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("status");
      }


             if (!isSeitLadenVeraendertStatus) {
          isSeitLadenVeraendertStatus = thisAttributChanged;
         if (isSeitLadenVeraendertStatus){
           wertNachLadenStatus=this.status;
         }
       }
      

       this.status = statusInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "STIMMZETTEL_TEAM", nullable = StimmzettelConstants.STIMMZETTEL_TEAM_NULLABLE)
    
  protected de.ivu.elect.business.stimmzettel.entity.StimmzettelTeam stimmzettelTeam =  de.ivu.elect.business.stimmzettel.entity.StimmzettelTeam.UNBEKANNT;

  @javax.persistence.Transient
  protected boolean hasChangedStimmzettelTeam = false;

  public boolean hasChangedStimmzettelTeam(){
    return hasChangedStimmzettelTeam;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertStimmzettelTeam = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.stimmzettel.entity.StimmzettelTeam wertNachLadenStimmzettelTeam;
  
  /**
   * 
   *
   * getter for STIMMZETTEL.STIMMZETTEL_TEAM
   */
    @Override   public  de.ivu.elect.business.stimmzettel.entity.StimmzettelTeam getStimmzettelTeam() {
        return stimmzettelTeam;
      }

  /**
   * 
   *
   * setter for STIMMZETTEL.STIMMZETTEL_TEAM
   *
   * @param stimmzettelTeam
   */
  @Override   public void setStimmzettelTeam( de.ivu.elect.business.stimmzettel.entity.StimmzettelTeam stimmzettelTeam) {

       resetTkCache();
                  de.ivu.elect.business.stimmzettel.entity.StimmzettelTeam stimmzettelTeamInternal = stimmzettelTeam;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.stimmzettelTeam
      , stimmzettelTeamInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedStimmzettelTeam |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("stimmzettelTeam");
      }


             if (!isSeitLadenVeraendertStimmzettelTeam) {
          isSeitLadenVeraendertStimmzettelTeam = thisAttributChanged;
         if (isSeitLadenVeraendertStimmzettelTeam){
           wertNachLadenStimmzettelTeam=this.stimmzettelTeam;
         }
       }
      

       this.stimmzettelTeam = stimmzettelTeamInternal;

         }

        
      @javax.persistence.Column(name = "VERSIONSNUMMER", nullable = StimmzettelConstants.VERSIONSNUMMER_NULLABLE, precision=StimmzettelConstants.VERSIONSNUMMER_PRECISION, scale=StimmzettelConstants.VERSIONSNUMMER_SCALE)
            
  protected java.lang.Long versionsnummer =  Long.valueOf("0");

  @javax.persistence.Transient
  protected boolean hasChangedVersionsnummer = false;

  public boolean hasChangedVersionsnummer(){
    return hasChangedVersionsnummer;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertVersionsnummer = false;
     @javax.persistence.Transient
     private transient java.lang.Long wertNachLadenVersionsnummer;
  
  /**
   * 
   *
   * getter for STIMMZETTEL.VERSIONSNUMMER
   */
    @Override   public  java.lang.Long getVersionsnummer() {
        return versionsnummer;
      }

  /**
   * 
   *
   * setter for STIMMZETTEL.VERSIONSNUMMER
   *
   * @param versionsnummer
   */
  @Override   public void setVersionsnummer( java.lang.Long versionsnummer) {

       resetTkCache();
                  java.lang.Long versionsnummerInternal = versionsnummer;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.versionsnummer
      , versionsnummerInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedVersionsnummer |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("versionsnummer");
      }


             if (!isSeitLadenVeraendertVersionsnummer) {
          isSeitLadenVeraendertVersionsnummer = thisAttributChanged;
         if (isSeitLadenVeraendertVersionsnummer){
           wertNachLadenVersionsnummer=this.versionsnummer;
         }
       }
      

       this.versionsnummer = versionsnummerInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */
  /**
   * Beziehung (unidirektional) zu CustomDataStorage
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=true, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "CUSTOM_DATA_STORAGE_ID", referencedColumnName="CUSTOM_DATA_STORAGE_ID"))
  protected de.ivu.elect.business.customdata.entity.CustomDataStorage customDataStorage;

  /**
   * 
   */
  @Override
  public void setCustomDataStorage(@javax.annotation.Nullable  de.ivu.elect.business.customdata.entity.CustomDataStorage customDataStorage){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.customDataStorage
    , customDataStorage);

    attributeChanged |= thisAttributChanged;

    hasChangedCustomDataStorage |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("customDataStorage");
    }

    this.customDataStorage = customDataStorage;
      }

  /**
   * 
   */
  @javax.annotation.Nullable   @Override
  public de.ivu.elect.business.customdata.entity.CustomDataStorage getCustomDataStorage(){
    return this.customDataStorage;
  }

  @javax.persistence.Transient
  protected boolean hasChangedCustomDataStorage = false;

  public boolean hasChangedCustomDataStorage(){
    return hasChangedCustomDataStorage;
  }

  /**
   * Beziehung (unidirektional) zu Gebiet
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "GEBIET_ID", referencedColumnName="GEBIET_ID"))
  protected de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet;

  /**
   * 
   */
  @Override
  public void setGebiet( de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.gebiet
    , gebiet);

    attributeChanged |= thisAttributChanged;

    hasChangedGebiet |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("gebiet");
    }

    this.gebiet = gebiet;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.gebietsbaum.entity.Gebiet getGebiet(){
    return this.gebiet;
  }

  @javax.persistence.Transient
  protected boolean hasChangedGebiet = false;

  public boolean hasChangedGebiet(){
    return hasChangedGebiet;
  }


/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("Stimmzettel:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(Stimmzettel other){
                             other.bemerkung = this.bemerkung;
                                other.erfasser = this.erfasser;
                                other.erfassungszeitpunkt = this.erfassungszeitpunkt;
                                other.gueltigkeit = this.gueltigkeit;
                                other.nummer = this.nummer;
                                other.status = this.status;
                                other.stimmzettelTeam = this.stimmzettelTeam;
                                other.versionsnummer = this.versionsnummer;
           
  other.setCustomDataStorage(this.getCustomDataStorage());
  other.setGebiet(this.getGebiet());
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(Stimmzettel.class)){
        copyEntityAttributesUsingSetter((Stimmzettel) other.castTo(Stimmzettel.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von Stimmzettel: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(Stimmzettel other){
               other.setBemerkung(this.bemerkung);
                  other.setErfasser(this.erfasser);
                  other.setErfassungszeitpunkt(this.erfassungszeitpunkt);
                  other.setGueltigkeit(this.gueltigkeit);
                  other.setNummer(this.nummer);
                  other.setStatus(this.status);
                  other.setStimmzettelTeam(this.stimmzettelTeam);
                  other.setVersionsnummer(this.versionsnummer);
           other.setCustomDataXml(this.getCustomDataXml());
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(Stimmzettel other){
                       if (hasChangedBemerkung) {
        other.setBemerkung(this.bemerkung);
      }
                             if (hasChangedErfasser) {
        other.setErfasser(this.erfasser);
      }
                             if (hasChangedErfassungszeitpunkt) {
        other.setErfassungszeitpunkt(this.erfassungszeitpunkt);
      }
                             if (hasChangedGueltigkeit) {
        other.setGueltigkeit(this.gueltigkeit);
      }
                             if (hasChangedNummer) {
        other.setNummer(this.nummer);
      }
                             if (hasChangedStatus) {
        other.setStatus(this.status);
      }
                             if (hasChangedStimmzettelTeam) {
        other.setStimmzettelTeam(this.stimmzettelTeam);
      }
                             if (hasChangedVersionsnummer) {
        other.setVersionsnummer(this.versionsnummer);
      }
             }




    /**
    * Hat die Entität überhaupt einen CustomDataStorage?
    */
    private boolean isCustomDataSupported() {
      return getCustomDataStorage()!=null;
    }

    @Override
    public de.ivu.elect.jee.entity.customdata.CustomData getCustomData() {
      if (isCustomDataSupported()) {
        de.ivu.elect.jee.entity.customdata.CustomData result = getCustomDataStorage().getCustomData();
        result.setTechnicalEntity(this); // Fachliche Entität bei jedem Zugriff setzen
        return result;
      }
      return de.ivu.elect.jee.entity.customdata.EmptyCustomData.INSTANCE;
    }


    @Override
    @SuppressWarnings("unchecked")
    public <T extends de.ivu.elect.jee.entity.customdata.CustomData> T getCustomData(Class<T> clazz) {
      if (isCustomDataSupported()) {
        return (T) getCustomData();
      }
      throw new IllegalStateException("Entität Stimmzettel besitzt kein CustomDataStorage: "+this);
    }


    @Override
    public void updateCustomData() {
      if (isCustomDataSupported()) {
        getCustomDataStorage().updateCustomData();
      }
    }


    public void clearCustomDataCache() {
      if (isCustomDataSupported()) {
        getCustomDataStorage().clearCustomDataCache();
      }
    }

    @Override
    public String getCustomDataXml(){
      if (isCustomDataSupported()) {
        return getCustomDataStorage().getCustomDataXml();
      }
      return "";
    }

    @Override
    public void setCustomDataXml(String customDataXml){
      if (isCustomDataSupported()) {
        if (org.apache.commons.lang3.StringUtils.isBlank(customDataXml)) {
          if (de.ivu.elect.business.system.control.FailOnUnkownCustomData.FAIL_ON_UNKNOWN_CUSTOM_DATA) {
            throw new IllegalStateException("Entität Stimmzettel hat CustomDataStorage, soll aber kein CustomData aufnehmen: '"+customDataXml+"'");
          }
          // ELECTMUC-2581
          System.err.println("Entität Stimmzettel hat CustomDataStorage, soll aber kein CustomData aufnehmen: '"+customDataXml+"'");
        } else {
          getCustomDataStorage().setCustomDataXml(customDataXml);
        }
        clearCustomDataCache(); // WASDE-1131
      } else {
       if (org.apache.commons.lang3.StringUtils.isNotBlank(customDataXml)) {
         if (customDataXml.endsWith("EmptyCustomData/>")) {
            // Abwärtskompatibilität...alles gut, die alten, leeren CustomDataObjekte...
         } else {
           if (de.ivu.elect.business.system.control.FailOnUnkownCustomData.FAIL_ON_UNKNOWN_CUSTOM_DATA) {
             throw new IllegalStateException("Entität Stimmzettel hat kein CustomDataStorage, soll aber CustomData aufnehmen: '"+customDataXml+"'");
           }
           // ELECT-5122
           System.err.println("Entität Stimmzettel hat kein CustomDataStorage, soll aber CustomData aufnehmen: '"+customDataXml+"'");
         }
       }
      }
    }

    public boolean hasChangedCustomDataXml() {
      if (isCustomDataSupported()) {
        return getCustomDataStorage().hasChangedCustomDataXml();
      }
      return false;
    }


    @javax.persistence.Transient
    private transient StimmzettelTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public StimmzettelTK getStimmzettelTK(){
    if (tkCache==null) {
    tkCache = new StimmzettelTK(

getNummer()
,   (getGebiet() == null) ? null : getGebiet().getGebietTK()


  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getStimmzettelTK();
    }

  @Override
  public StimmzettelUK getUk(){
    return getStimmzettelUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return Stimmzettel.class;
  }

public StimmzettelUK getStimmzettelUK(){

   return  new StimmzettelUK(

getNummer()
,     getGebiet()==null?null:getGebiet().getGebietUK()


  );
}

  @javax.persistence.Transient
  private transient StimmzettelProperties properties;

  public StimmzettelProperties getProperties(){
    if (properties == null) {
      properties = new StimmzettelProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public StimmzettelProperties getStimmzettelProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return StimmzettelConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
     
      if (werteVorher.containsKey(StimmzettelConstants.MESSAGE_KEY_BEMERKUNG_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(StimmzettelConstants.MESSAGE_KEY_BEMERKUNG_EINZAHL);

        bemerkung =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(StimmzettelConstants.MESSAGE_KEY_ERFASSER_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(StimmzettelConstants.MESSAGE_KEY_ERFASSER_EINZAHL);

        erfasser =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(StimmzettelConstants.MESSAGE_KEY_ERFASSUNGSZEITPUNKT_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(StimmzettelConstants.MESSAGE_KEY_ERFASSUNGSZEITPUNKT_EINZAHL);

        erfassungszeitpunkt =
     vorher.getAttributTyp().getValueAsDate(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(StimmzettelConstants.MESSAGE_KEY_GUELTIGKEIT_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(StimmzettelConstants.MESSAGE_KEY_GUELTIGKEIT_EINZAHL);

        gueltigkeit =
     (de.ivu.elect.business.stimmzettel.entity.StimmzettelGueltigkeit) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(StimmzettelConstants.MESSAGE_KEY_NUMMER_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(StimmzettelConstants.MESSAGE_KEY_NUMMER_EINZAHL);

        nummer =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(StimmzettelConstants.MESSAGE_KEY_STATUS_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(StimmzettelConstants.MESSAGE_KEY_STATUS_EINZAHL);

        status =
     (de.ivu.elect.business.stimmzettel.entity.StimmzettelStatus) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(StimmzettelConstants.MESSAGE_KEY_STIMMZETTEL_TEAM_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(StimmzettelConstants.MESSAGE_KEY_STIMMZETTEL_TEAM_EINZAHL);

        stimmzettelTeam =
     (de.ivu.elect.business.stimmzettel.entity.StimmzettelTeam) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(StimmzettelConstants.MESSAGE_KEY_VERSIONSNUMMER_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(StimmzettelConstants.MESSAGE_KEY_VERSIONSNUMMER_EINZAHL);

        versionsnummer =
                        vorher.getAttributTyp().getValueAsLong(vorher.getWertVorher());
                  }

                }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                        if (isSeitLadenVeraendertBemerkung) {
      result.put(StimmzettelConstants.MESSAGE_KEY_BEMERKUNG_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenBemerkung , bemerkung));
    }
                            if (isSeitLadenVeraendertErfasser) {
      result.put(StimmzettelConstants.MESSAGE_KEY_ERFASSER_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenErfasser , erfasser));
    }
                            if (isSeitLadenVeraendertErfassungszeitpunkt) {
      result.put(StimmzettelConstants.MESSAGE_KEY_ERFASSUNGSZEITPUNKT_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.TIMESTAMP
                , wertNachLadenErfassungszeitpunkt , erfassungszeitpunkt));
    }
                            if (isSeitLadenVeraendertGueltigkeit) {
      result.put(StimmzettelConstants.MESSAGE_KEY_GUELTIGKEIT_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenGueltigkeit , gueltigkeit));
    }
                            if (isSeitLadenVeraendertNummer) {
      result.put(StimmzettelConstants.MESSAGE_KEY_NUMMER_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenNummer , nummer));
    }
                            if (isSeitLadenVeraendertStatus) {
      result.put(StimmzettelConstants.MESSAGE_KEY_STATUS_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenStatus , status));
    }
                            if (isSeitLadenVeraendertStimmzettelTeam) {
      result.put(StimmzettelConstants.MESSAGE_KEY_STIMMZETTEL_TEAM_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenStimmzettelTeam , stimmzettelTeam));
    }
                            if (isSeitLadenVeraendertVersionsnummer) {
      result.put(StimmzettelConstants.MESSAGE_KEY_VERSIONSNUMMER_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
                                    de.ivu.elect.jee.protokollierung.AttributTyp.LONG
                            , wertNachLadenVersionsnummer , versionsnummer));
    }
                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                      isSeitLadenVeraendertBemerkung = false;
      wertNachLadenBemerkung = null;
                          isSeitLadenVeraendertErfasser = false;
      wertNachLadenErfasser = null;
                          isSeitLadenVeraendertErfassungszeitpunkt = false;
      wertNachLadenErfassungszeitpunkt = null;
                          isSeitLadenVeraendertGueltigkeit = false;
      wertNachLadenGueltigkeit = null;
                          isSeitLadenVeraendertNummer = false;
      wertNachLadenNummer = null;
                          isSeitLadenVeraendertStatus = false;
      wertNachLadenStatus = null;
                          isSeitLadenVeraendertStimmzettelTeam = false;
      wertNachLadenStimmzettelTeam = null;
                          isSeitLadenVeraendertVersionsnummer = false;
      wertNachLadenVersionsnummer = null;
                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
                            return result;
  }

        
            protected String getInitialDiscriminator() {
              return "STIMMZETTEL";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "Stimmzettel";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

  @javax.persistence.Transient
  private transient boolean hashCodeBerechnet = false;

  @javax.persistence.Transient
  private transient int hashCode = 0;


  @Deprecated // nur in Unit-Tests verwenden(!)
  public void resetHashCode() {
    hashCodeBerechnet = false;
    hashCode = 0;
  }

  @Override
    public int hashCode() {
      if (hashCodeBerechnet) {
      return hashCode;
    }

    if (id == null) {
      hashCode = super.hashCode();
    } else {
      hashCode = id.hashCode();
    }

    hashCodeBerechnet = true;

    return hashCode;

    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(StimmzettelConstants.BEMERKUNG_MAX_LENGTH ,  bemerkung, this, StimmzettelConstants.MESSAGE_KEY_BEMERKUNG_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(StimmzettelConstants.ERFASSER_MAX_LENGTH ,  erfasser, this, StimmzettelConstants.MESSAGE_KEY_ERFASSER_EINZAHL, validationResult);
                                                                                                                    de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(gueltigkeit, this, StimmzettelConstants.MESSAGE_KEY_GUELTIGKEIT_EINZAHL, validationResult);
                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(nummer, this, StimmzettelConstants.MESSAGE_KEY_NUMMER_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(StimmzettelConstants.NUMMER_MAX_LENGTH , 1 ,  nummer, this, StimmzettelConstants.MESSAGE_KEY_NUMMER_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(status, this, StimmzettelConstants.MESSAGE_KEY_STATUS_EINZAHL, validationResult);
                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(stimmzettelTeam, this, StimmzettelConstants.MESSAGE_KEY_STIMMZETTEL_TEAM_EINZAHL, validationResult);
                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(versionsnummer, this, StimmzettelConstants.MESSAGE_KEY_VERSIONSNUMMER_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkValueRange(StimmzettelConstants.VERSIONSNUMMER_MAX_VALUE, StimmzettelConstants.VERSIONSNUMMER_MIN_VALUE, versionsnummer, this, StimmzettelConstants.MESSAGE_KEY_VERSIONSNUMMER_EINZAHL, validationResult);
                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        protected transient java.util.Map<String, Object> transientContext;

        @Override
        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }
                              }
